﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'SimpMnu Class module
'
'Author:
'  Markus Stipp Ver: 1.0 (original)
'  CanalRun     Ver: 2.0

'Class module
Private Sub Class_Globals
  Private mModule As Object
  Private mEventName As String

  Public pnMask As Panel
  Public svMenu As ScrollView
  
  Public itemHeight As Int = 50dip
  Public itemVSpc As Int = 2dip
  Public itemHSpc As Int = 2dip
  
  Public itemTxtSz As Int = 16
  Public itemTxtClr As Int = Colors.ARGB(255, 0,0,0)
  Public itemDsbTxtClr As Int = Colors.ARGB(255, 150,150,150)

  Public MnuItmColor As Int = Colors.ARGB(255, 255,255,255)
  Public MnuPrsColor As Int = Colors.ARGB(255, 255,216,0)
End Sub

'Initializes the SlideMenu object
' Activity - Pass a reference to the Activity here where the Slidemenu should be added to.
' Module - The calling Module. Pass the "Me" reference here
' EventNAme - EventName for the Click event

Sub Initialize(Act As Activity, Mdl As Object, EvNam As String)
  mModule = Mdl
  mEventName = EvNam
  
  pnMask.Initialize("pnMask")
  pnMask.Color = Colors.ARGB(100, 0,0,0)
  
  Act.AddView(pnMask, 0, 0, 100%x, 100%y)
  
  svMenu.Initialize(10)
  svMenu.Color = Colors.Gray
  svMenu.Panel.Color = Colors.Gray

  pnMask.AddView(svMenu, 0, Act.Height * 0.10, Act.Width * 0.30, Act.Height * 0.80)
  
  vwShow(pnMask, False)
End Sub

' Show the Menu
'   items - List of items for menu (string with 2 or 3 vertical bar separated fields)
'     for button items provide - name|text
'     for checkbox items provide - name|text|checked ("False" or "True")

Public Sub ShowMenu(items As List)
  Dim px, py As Int
  Dim lb As Label
  Dim pn As Panel
  Dim itm As String
  Dim enb, psd As ColorDrawable
  Dim sld As StateListDrawable
  
  svMenu.Panel.Width = svMenu.Width
  svMenu.Panel.RemoveAllViews
  
  For i=0 To items.Size-1
    itm = items.Get(i)
	
    Dim sa() As String = Regex.Split("\|", itm)
	' sa(0)-name, sa(1)-text, sa(2)-not avail or checked (string "True" or "False")

    enb.Initialize(MnuItmColor, 0)
    psd.Initialize(MnuPrsColor, 0)

    sld.Initialize
    sld.AddState(sld.State_Pressed, psd)
    sld.AddState(sld.State_Enabled, enb)
  
    pn.Initialize("MnuItem")
    pn.Background = sld
    pn.Tag = sa ' Item panel Tag holds menu item definition string array
  
    py = svMenu.Panel.NumberOfViews * (itemVSpc + itemHeight)
    svMenu.Panel.AddView(pn, 0, py, svMenu.Width, itemHeight)
  
    px = 0
  
    If (sa.Length = 3) Then ' has checkbox defined
      Dim iv As ImageView
	
      iv.Initialize("")
      pn.AddView(iv, px, 0, itemHeight, itemHeight) ' checkbox is at panel view 0
	
      SetItmChk(iv, sa(2))    
      px = itemHeight + itemHSpc
    End If
  
    lb.Initialize("")
    lb.Text = sa(1)
    lb.TextColor = itemTxtClr
    lb.TextSize = itemTxtSz

    If (sa.Length = 3) Then
      lb.Gravity = Bit.OR(Gravity.LEFT, Gravity.CENTER_VERTICAL)
    Else
      lb.Gravity = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)
    End If
    
    pn.AddView(lb, px, 0, svMenu.Width - px, itemHeight) ' label at view 0 or view 1
  Next
  
  Dim h As Int = svMenu.Panel.NumberOfViews * (itemHeight + itemVSpc)
  
  If (h < svMenu.Height) Then
    Dim pn As Panel
	pn.Initialize("")
	pn.Color = MnuItmColor
	svMenu.Panel.AddView(pn, 0, h, svMenu.Width, svMenu.Height - h) 
  End If

  svMenu.Panel.Height = Max(svMenu.Height, h - itemVSpc)
  
  vwShow(pnMask, True)
End Sub

Public Sub IsShowing As Boolean
  Return(pnMask.Visible)
End Sub

Public Sub HideMenu
  vwShow(pnMask, False)
End Sub

Private Sub MnuItem_Click
  Dim pn As Panel
  
  pn = Sender
  Dim sa() As String = pn.Tag
  
  If (sa.Length = 3) Then ' has checkbox, was clicked, invert
    If (sa(2).ToLowerCase = "true") Then
	  sa(2) = "False"
	Else If (sa(2).ToLowerCase = "false") Then
	  sa(2) = "True"
	End If
  End If
  
  Dim evn As String = mEventName & "_Click"
  
  If SubExists(mModule, evn) Then CallSubDelayed2(mModule, evn, pn)
End Sub

Public Sub SetItmChk(iv As ImageView, ck As String)
  If (ck.ToLowerCase = "true") Then
    iv.Bitmap = LoadBitmap(File.DirAssets, "ckbxc.png")
  Else
    iv.Bitmap = LoadBitmap(File.DirAssets, "ckbxu.png")
  End If
End Sub

Private Sub vwShow(vw As View, flg As Boolean)
  If (vw.Visible = flg) Then Return
  
  vw.Enabled = flg
  vw.Visible = flg
  
  If (flg) Then vw.BringToFront Else vw.SendToBack
End Sub

Private Sub pnMask_Click
  HideMenu
End Sub

Private Sub pnMask_LongClick
  HideMenu
End Sub

